#!/usr/bin/sh
set -e

size=8G
[ -n "$1" ] && size="$1"

free_bytes="$(($(stat -f --format="%a*%S" .)))"
size_bytes="$(numfmt --from=auto "$size")"
need=$((2 * $size_bytes))

if [ "$free_bytes" -lt "$need" ]; then
    echo "Not enough free disk space to allocate swap"
    exit 1
fi

btrfs subvolume create /var/swap
chattr +C /var/swap
fallocate -l "$size" /var/swap/swapfile
chmod 0600 /var/swap/swapfile

semanage fcontext -a -t var_t -f d '/var/swap' || true
semanage fcontext -a -t swapfile_t -f f '/var/swap/swapfile' || true
restorecon -v -r '/var/swap'

mkswap /var/swap/swapfile
swapon /var/swap/swapfile
grep -q /var/swap/swapfile /etc/fstab || echo '/var/swap/swapfile swap swap sw 0 0' >> /etc/fstab

# If we got this far, disable it for good measure (even though it should not run again)
systemctl disable asahi-setup-swap-firstboot.service
